#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "omp.h"

#define N 10
#define NUMBER_OF_THREADS 2

int main(int argc, char *argv[])
{
	int a[10] = {0,1,2,3,4,5,6,7,8,9};
	int b[10] = {0,0,0,0,0,0,0,0,0,0};

    int i;
    #pragma omp parallel num_threads( NUMBER_OF_THREADS )
    {
        int id = omp_get_thread_num();
        #pragma omp for nowait schedule(dynamic,4)
        for (i = 0; i < N; i++){
			a[i] = a[i] + i;
			printf("thread %d doing iteration %d of loop 1\n", id, i);
			if( i == 6 )
				sleep(1);
		}

		#pragma omp for schedule(dynamic,4)
        for (i = 0; i < N; i++) {
			printf("thread %d doing iteration %d of loop 2\n", id, i);
			b[i] = 2 * a[i];
		}
    }

	printf("a = [");
    for (i = 0; i < N; i++)
		printf("%d ", a[i]);
	printf("]\n");

	printf("b = [");
    for (i = 0; i < N; i++)
		printf("%d ", b[i]);
	printf("]\n");

    return 0;
}

